<?php

namespace ForceSSL;

class App
{
    public function __construct()
    {

        // Basic force
        $this->forceSSL();

        //Redirects
        add_action('template_redirect', array($this, 'redirectToSSL'), 5);
        add_action('admin_init', array($this, 'redirectToSSL'), 5);
        add_action('login_init', array($this, 'redirectToSSL'), 5);
        add_action('rest_api_init', array($this, 'redirectToSSL'), 5);

        //Sanitazion
        add_filter('the_permalink', array($this, 'makeUrlProtocolLess'), 700);
        add_filter('wp_get_attachment_url', array($this, 'makeUrlProtocolLess'), 700);
        add_filter('wp_get_attachment_image_src', array($this, 'makeUrlProtocolLess'), 700);
        add_filter('script_loader_src', array($this, 'makeUrlProtocolLess'), 700);
        add_filter('style_loader_src', array($this, 'makeUrlProtocolLess'), 700);
        add_filter('the_content', array($this, 'replaceInlineUrls'), 700);
        add_filter('widget_text', array($this, 'replaceInlineUrls'), 700);

        //Fix site url / home url
        add_filter('option_siteurl', array($this, 'makeUrlProtocolLess'), 700);
        add_filter('option_home', array($this, 'makeUrlProtocolLess'), 700);

    }

    public function forceSSL()
    {
        if (!$this->isUsingSSLProxy()) {
            if (!defined('FORCE_SSL_ADMIN')) {
                define('FORCE_SSL_ADMIN', true);
            }
            if (!defined('FORCE_SSL_LOGIN')) {
                define('FORCE_SSL_LOGIN', true);
            }
        } else {
            if (strpos($_SERVER['HTTP_X_FORWARDED_PROTO'], 'https') !== false) {
                $_SERVER['HTTPS']='on';
            }
        }
    }

    public function redirectToSSL()
    {
        if (!is_ssl() && !$this->isUsingSSLProxy()) {
            wp_redirect('https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'], 301);
            exit();
        }
    }

    public function makeUrlProtocolLess($url)
    {
        return preg_replace("(^https?://)", "//", $url);
    }

    public function replaceInlineUrls($content)
    {
        return str_replace(home_url("/", "http"), $this->makeUrlProtocolLess(home_url("/", "https")), $content);
    }

    public function isUsingSSLProxy()
    {
        if ((defined('SSL_PROXY') && SSL_PROXY === true)) {
            return true;
        }
        return false;
    }
}
